{

                        A Disassembler
                             for
                         SPMI P-code





 This program provides a disassembly facility for the P-machine  P-
 code generated by the model compiler. The program is summarised by
 its heading which is as follows:-

                                                                     }

                           program

          Disassembler( CodeFile, CodeMap, Output );

{

 The program parameters have the following nature and purpose.

 CodeFile  is the code file generated by the compiler. It  contains
           directly  executable  P-code  structured  as a series of
           code and jump tables.

 CodeMap   is the code map generated by the  compiler.  It  enables
           the disassembler to deduce the size of the code and jump
           tables that comprise the code file.

 Output    is the textfile on which the disassembly is written.

 The disassembler produces a formatted display of the code and jump
 tables  for  each procedure compiled. For a jump table, the column
 labelled 'Memory Word' gives the P-machine word  address  of  each
 word, and the column labelled 'Memory Content' gives an associated
 code address. In addition, the column labelled 'Index'  gives  the
 index value by which the jump table location is referenced.

 For a code table, the Memory Word  column  is  supplemented  by  a
 corresponding column giving the 'Memory Byte' address. The indivi-
 dual P-code decimal values are printed out  under  column  'Memory
 Content',  and  are  supplemented  by  the  P-code mnemonic in the
 column labelled 'P-code'. The arguments of each P-code are printed
 in  decimal,  but for in-line constants, this is supplemented by a
 character, string or hexadecimal representation as appropriate.

 The last jump-table derives from the pseudo-block  containing  the
 main  program  block,  and  has  no  corresponding code-table. The
 entries at Index locations [5] and [6] of this jump table  contain
 the  entry points of internally generated procedures to initialise
 and finalise text-files. The entry at location [37]  contains  the
 entry point of the main program block.

 The disassembly is concluded with usage statistics for each  class
 of P-code.


 Copyright  (C)     University of Manchester
                    Institute of Science and Technology
                    January 1984.

                                                                     }
label

   13 ;



const


   {*************************************************************************}
   {*************************************************************************}
   {******                                                             ******}
   {******                                                             ******}
   {******                     Host Installation                       ******}
   {******                     -----------------                       ******}
   {******                                                             ******}
   {******                                                             ******}
   {****** 1. Investigate how your host Pascal processor implements    ******}
   {******    the variable:-                                           ******}
   {******                                                             ******}
   {******      HostWord : set of B0..Bn                               ******}
   {******                                                             ******}
   {******    If member B0 is mapped onto the most significant bit     ******}
   {******    position, then set the constant HostBitOrder to the      ******}
   {******    value LeftToRight.  Otherwise, set it to RightToLeft.    ******}
   {******                                                             ******}
   {****** 2. Investigate how your host Pascal processor implements    ******}
   {******    the packed variable:-                                    ******}
   {******                                                             ******}
   {******      HostWord : packed array [0..n] of char                 ******}
   {******                                                             ******}
   {******    If element HostWord[0] is mapped onto the most           ******}
   {******    significant byte position, then set the constant         ******}
   {******    HostByteOrder to the value LeftToRight. Otherwise, set   ******}
   {******    it to RightToLeft.                                       ******}
   {******                                                             ******}
   {****** 3. Set MaxHostChar to the largest host 'character value'.   ******}
   {******                                                             ******}
   {****** 4. Redefine the Constants prefixed 'MC' for the host        ******}
   {******    machine.                                                 ******}
   {******                                                             ******}
   {******                                                             ******}
   {*************************************************************************}
   {*************************************************************************}



   LeftToRight = 0 ;
   RightToLeft = 1 ;

   HostBitOrder  = RightToLeft ;        { for host Pascal compiler }
   HostByteOrder = LeftToRight ;
   MaxHostChar   = 255 ;                { for most character-sets   }



   { configuring constants }

   VerNum         = 4 ;                 { this version }
   RelNum         = 1 ;                 { this release }

   CodeLimit      = 512 ;               { max code segment size in words  }
   DataLimit      = 256 ;               { max data segment size in words  }




   { constants describing the model P-machine }

   MCBitsPerWord  = 32 ;                { bits per memory-word }
   MCWordSetBits  = 31 ;                { bits per set-word }
   MCBitsPerByte  = 8  ;                { bits per memory-byte }
   MCBytesPerWord = 4  ;                { mcbitsperword div mcbitsperbyte }
   MCMaxBitNum    = 31 ;                { mcbitsperword-1 }
   MCMaxSetBit    = 30 ;                { mcwordsetbits-1 }
   MCMaxByteNum   = 3 ;                 { mcbytesperword-1 }

   MCMaxByte      = 255 ;               { max mc-byte value }
   MCMaxint       = 2147483647 ;        { max mc-integer value }
   MCMaxChar      = 255 ;               { max mc-char value }

   MCMaxMemWord   = 16383 ;             { max memory-word address }
   MCMaxMemByte   = 65535 ;             { max memory-byte address }



   { P-machine class 1 operations }


   cons0  =   0 ; cons1  =   1 ; cons2  =   2 ; cons3  =   3 ; cons4  =   4 ;
   cons5  =   5 ; cons6  =   6 ; cons7  =   7 ; cons8  =   8 ; cons9  =   9 ;
   cons10 =  10 ; cons11 =  11 ; cons12 =  12 ; cons13 =  13 ; cons14 =  14 ;
   cons15 =  15 ; cons16 =  16 ; cons17 =  17 ; cons18 =  18 ; cons19 =  19 ;
   cons20 =  20 ; cons21 =  21 ; cons22 =  22 ; cons23 =  23 ; cons24 =  24 ;
   cons25 =  25 ; cons26 =  26 ; cons27 =  27 ; cons28 =  28 ; cons29 =  29 ;
   cons30 =  30 ; cons31 =  31 ; consb  =  32 ; consw  =  33 ; conmb  =  34 ;
   conmw  =  35 ; crefb  =  36 ; crefw  =  37 ; csetb  =  38 ; csetw  =  39 ;
   lodl0  =  40 ; lodl1  =  41 ; lodl2  =  42 ; lodl3  =  43 ; lodl4  =  44 ;
   lodl5  =  45 ; lodl6  =  46 ; lodl7  =  47 ; lodlb  =  48 ; lodlw  =  49 ;
   lrf0   =  50 ; lrf1   =  51 ; lrf2   =  52 ; lrf3   =  53 ; lrf4   =  54 ;
   lrf5   =  55 ; lrf6   =  56 ; lrf7   =  57 ; lrflb  =  58 ; lrflw  =  59 ;
   stol0  =  60 ; stol1  =  61 ; stol2  =  62 ; stol3  =  63 ; stol4  =  64 ;
   stol5  =  65 ; stol6  =  66 ; stol7  =  67 ; stolb  =  68 ; stolw  =  69 ;
   lodgb  =  70 ; lodgw  =  71 ; lrfgb  =  72 ; lrfgw  =  73 ; stogb  =  74 ;
   stogw  =  75 ; lodeb  =  76 ; lodew  =  77 ; lrfeb  =  78 ; lrfew  =  79 ;
   stoeb  =  80 ; stoew  =  81 ; lodib  =  82 ; lodiw  =  83 ; lrfib  =  84 ;
   lrfiw  =  85 ; stoib  =  86 ; stoiw  =  87 ; lodin  =  88 ; indx1  =  89 ;
   indx2  =  90 ; indx3  =  91 ; indx4  =  92 ; indx5  =  93 ; indx6  =  94 ;
   indx7  =  95 ; indxb  =  96 ; indxw  =  97 ; ixrfb  =  98 ; ixrfw  =  99 ;
   ixcap  = 100 ; stoin  = 101 ; adjpb  = 102 ; adjpw  = 103 ; adjp1  = 104 ;
   adjmb  = 105 ; adjmw  = 106 ; adjm1  = 107 ; adadr  = 108 ; lodbt  = 109 ;
   lodpk  = 110 ; stobt  = 111 ; stopk  = 112 ; ixpkb  = 113 ; ixpcap = 114 ;
   ixswb  = 115 ; adjpk  = 116 ; lodby  = 117 ; stoby  = 118 ; lbyrf  = 119 ;
   ibyrf  = 120 ; lodmb  = 121 ; lodmw  = 122 ; stomb  = 123 ; stomw  = 124 ;
   storb  = 125 ; storw  = 126 ; moveb  = 127 ; movew  = 128 ; szcap  = 129 ;
   mvcap  = 130 ; dpcap  = 131 ; rlcap  = 132 ; andop  = 133 ; notop  = 134 ;
   incrb  = 135 ; incrw  = 136 ; incr1  = 137 ; decrb  = 138 ; decrw  = 139 ;
   decr1  = 140 ; absint = 141 ; negint = 142 ; sqrint = 143 ; addint = 144 ;
   subint = 145 ; mulint = 146 ; divint = 147 ; modint = 148 ; oddint = 149 ;
   eqint  = 150 ; neint  = 151 ; ltint  = 152 ; leint  = 153 ; chktv  = 154 ;
   chktd  = 155 ; chklm  = 156 ; chklw  = 157 ; chkup  = 158 ; chkcap = 159 ;
   float  = 160 ; absrl  = 161 ; negrl  = 162 ; sqrl   = 163 ; addrl  = 164 ;
   subrl  = 165 ; mulrl  = 166 ; divrl  = 167 ; trurl  = 168 ; rndrl  = 169 ;
   eqrl   = 170 ; nerl   = 171 ; ltrl   = 172 ; lerl   = 173 ; lodptr = 174 ;
   eqptr  = 175 ; neptr  = 176 ; eqstr  = 177 ; nestr  = 178 ; ltstr  = 179 ;
   lestr  = 180 ; lodset = 181 ; stoset = 182 ; sglset = 183 ; rngset = 184 ;
   setuni = 185 ; setint = 186 ; setdif = 187 ; setexp = 188 ; eqset  = 189 ;
   neset  = 190 ; leset  = 191 ; inset  = 192 ; chksl  = 193 ; chksu  = 194 ;
   jmpfw  = 195 ; jmpbk  = 196 ; jmpvia = 197 ; jmpout = 198 ; fjpfw  = 199 ;
   fjpbk  = 200 ; fjpvia = 201 ; fjpcnd = 202 ; tjpcnd = 203 ; casejp = 204 ;
   mark   = 205 ; calglo = 206 ; calloc = 207 ; callev = 208 ; calotr = 209 ;
   calfml = 210 ; endp   = 211 ; endf   = 212 ; endmf  = 213 ; newp1b = 214 ;
   newp1w = 215 ; dspp1b = 216 ; dspp1w = 217 ; chkn1  = 218 ; chkd1  = 219 ;
   chkd2  = 220 ; noop   = 221 ; preset = 222 ; presrb = 223 ; presrw = 224 ;
   ldstk  = 225 ; dpstk  = 226 ; popstk = 227 ; chkwd  = 228 ; chkrp  = 229 ;
   chkvf  = 230 ; trapp  = 231 ; trapt  = 232 ; trapf  = 233 ; setlk  = 234 ;
   dislk  = 235 ; pglk   = 236 ; smpglk = 237 ; haltp  = 238 ; chkptr = 241 ;
   chkflw = 242 ; chkfup = 243 ; escape = 255 ;


   { P-machine class 2 operations }


   chkrd  =   0 ; chkwr  =   1 ; rewrtf =   2 ; resetf =   3 ; eolnf  =   4 ;
   eoff   =   5 ; getf   =   6 ; rdint  =   7 ; rdrl   =   8 ; rdln   =   9 ;
   putf   =  10 ; wrchar =  11 ; wrbool =  12 ; wrstr  =  13 ; wrint  =  14 ;
   wrflt  =  15 ; wrfix  =  16 ; wrln   =  17 ; pagef  =  18 ; closef =  19 ;
   pckpr  =  20 ; pckprc =  21 ; upkpr  =  22 ; upkprc =  23 ; sinf   =  24 ;
   cosf   =  25 ; expf   =  26 ; logf   =  27 ; sqrtf  =  28 ; arctnf =  29 ;
   mapp   =  30 ; chkbuf =  31 ;




   { control block format }

   SerialOffset   = 4 ;  { data[codebase-serialoffset] = 0/pmd block serial }
   LocksOffset    = 3 ;  { data[codebase-locksoffset]  = lock storeage      }
   LocalsOffset   = 2 ;  { data[codebase-localsoffset] = local storage      }
   ParamsOffset   = 1 ;  { data[codebase-paramsoffset] = parameter storage  }


   { formatting strings }

   Margin         = '     ' ;
   Blanks         = '                                            ' ;
   Dashes         = '-------------------------------------------' ;

   { formatting constants }

   MarginWidth    = 5 ;                 { margin spacing }
   OpFieldWidth   = 12 ;                { for 4 decimal values in [0..255] }


type



   { types applied globally }

   Scalar         = 0..maxint ;
   CodeRange      = 0..CodeLimit ;
   DataRange      = 1..DataLimit ;

   TokenKinds     = ( StartBody,FlowToken,EndBody ) ;
   MapToken      =  packed record
                       case Kind : TokenKinds of
                          StartBody,
                          FlowToken :
                             ( ) ;
                          EndBody :
                             ( JumpTableSize,CodeTableSize : Scalar )
                    end ;

   { types describing the model P-machine }

   MCBit          = 0..1 ;
   MCByte         = 0..MCMaxByte ;
   MCWord         = integer  ;          { target=host }
   MCScalar       = 0..MCMaxint ;       { target=host }
   MCInteger      = integer ;           { target=host }
   MCReal         = real ;              { target=host }
   MCBitRange     = 0..MCBitsPerWord ;
   MCBitIndex     = 0..MCMaxBitNum ;
   MCSetBits      = 0..MCMaxSetBit ;
   MCBitArray     = packed array[MCBitIndex] of MCBit ;
   MCByteIndex    = 0..MCMaxByteNum ;
   MCCharArray    = packed array[MCByteIndex] of char ;
   MCByteArray    = packed array[MCByteIndex] of MCByte ;
   MCWordSet      = set of MCSetBits ;


   WordCast       = ( AsSet,AsBits,AsBytes,AsChars,AsReal,AsValue ) ;
   MCWordForm     = record
                       case WordCast of
                          AsSet   : ( WSet : MCWordSet ) ;
                          AsBits  : ( WBits : MCBitArray ) ;
                          AsBytes : ( WBytes : MCByteArray ) ;
                          AsChars : ( WChars : MCCharArray ) ;
                          AsReal  : ( WReal : MCReal ) ;
                          AsValue : ( WValue : MCWord )
                    end ;

   WordRange      = 0..MCMaxMemWord ;
   ByteRange      = 0..MCMaxMemByte ;
   BitRange       = MCBitRange ;


   { types describing the model P-code }

   SixChars       = packed array[1..6] of char ;

   PcodeClasses   = ( Class1,Class2 ) ;
   PcodeByte      = 0..255 ;
   OpForms        = ( Implicit,Byte,DoubleByte,ByteString,Word,
                      WordByte,Table,None ) ;
   PcodeForm      = record
                       Mnemonic : SixChars ;
                       Operands : OpForms
                    end ;


   { types describing selected control options }

   OptionType    = ( Listing,CodeDump,Checks,PMDump,
                     Level,Programs,Margins,Other ) ;


   { types used by statistics reporter }

   Frequencies = array[PcodeByte] of Scalar ;




var


   Instruction : PcodeForm ;
   ModelPcode  : array[PcodeClasses,PcodeByte] of PcodeForm ;

   Pcounts : array[PcodeClasses] of Frequencies ;
   Logged : Scalar ;

   CodeFile : file of MCWord ;
   CodeMap : packed file of MapToken ;

   Control : array[OptionType] of MCWord ;

procedure MCGetByte(MachineWord: MCWordForm; ByteIndex: MCByteIndex;
                    var ResultByte: MCByte);

  begin
    { recast(machineword,asbytes) }
    if HostByteOrder = LeftToRight
    then ResultByte := ord(MachineWord.WChars[MCMaxByteNum - ByteIndex])
    else ResultByte := ord(MachineWord.WChars[ByteIndex])
  end { mcgetbyte };

procedure Error(errnum: Scalar);

  begin
    case errnum of
      1 : writeln(' *Error : unexpected end of CodeFile.');
      2 : writeln(' *Error : code segment>', CodeLimit: 1, ' words.');
      3 : writeln(' *Error : data segment>', DataLimit: 1, ' words.')
    end;
    goto 13
  end { error };

procedure Disassemble;

  var CodeSize, DataSize: Scalar;
      CodeWord: WordRange;
      Code: array [CodeRange] of MCWord;
      Data: array [DataRange] of MCWord;

  procedure ReadSizes;

    var EndOfBody: Boolean;

    begin
      CodeSize := 0;
      DataSize := 0;
      EndOfBody := false;
      repeat
        with CodeMap^ do
          if Kind = EndBody
          then
            begin
              CodeSize := CodeTableSize;
              DataSize := JumpTableSize;
              EndOfBody := true
            end;
        get(CodeMap)
      until EndOfBody or eof(CodeMap)
    end { readsizes };

  procedure ReadTables;

    var Index: Scalar;

    function NextCodeWord: MCWord;

      begin
        if eof(CodeFile)
        then Error(1)
        else
          begin
            NextCodeWord := CodeFile^;
            get(CodeFile)
          end
      end { nextcodeword };

    begin
      if DataSize > DataLimit
      then Error(3)
      else
        for Index := 1 to DataSize do Data[Index] := NextCodeWord;
      if CodeSize > CodeLimit
      then Error(2)
      else
        for Index := 0 to CodeSize - 1 do Code[Index] := NextCodeWord
    end { readtables };

  procedure DisplayTables;

    procedure JumpTable;

      var Index: DataRange;
          NegativeIndex: MCByte;

      begin
        writeln(Blanks, ':');
        writeln(Blanks, ':');
        writeln(Blanks, ':');
        writeln(' ', Dashes, ':', Dashes);
        writeln(Blanks, ':');
        writeln
          (Margin, 'Memory', Margin, 'Memory', Margin,
             '   Memory   ', Margin, ':', Margin, 'Jump Table');
        writeln
          (Margin, ' Word ', Margin, ' Byte ', Margin,
             '  Content   ', Margin, ':');
        writeln(Blanks, ':', Margin, ' Index');
        writeln(Blanks, ':');
        for Index := 1 to DataSize do
          begin
            NegativeIndex := DataSize - Index + 1;
            write
              (Margin, CodeWord: 5, Margin, ' ': 6, Margin,
                 Data[Index]: OpFieldWidth, Margin, ' :', Margin,
                   '[', NegativeIndex: 3, ']');
            if NegativeIndex = SerialOffset
            then write(Margin, '(Block Serial)');
            if NegativeIndex = LocksOffset
            then write(Margin, '(Lock Storage)');
            if NegativeIndex = LocalsOffset
            then write(Margin, '(Local Storage)');
            if NegativeIndex = ParamsOffset
            then write(Margin, '(Parameter Storage)');
            writeln;
            CodeWord := CodeWord + 1
          end;
        writeln(Blanks, ':')
      end { jumptable };

    procedure CodeTable;

      var OpCode: MCByte;
          CodeCounter, FirstByte, LastByte: ByteRange;
          i, Min, Max, Datum: MCWord;
          Size, CodeBase: WordRange;
          rvalue: MCReal;

      function NextByte: MCByte;

        var Buffer: MCWordForm;

        begin
          Buffer.WValue := Code[CodeCounter div MCBytesPerWord];

          { recast(buffer,asbytes) }
          NextByte := ord(Buffer.WChars[CodeCounter mod MCBytesPerWord]);
          CodeCounter := CodeCounter + 1
        end { nextbyte };

      function NextWord: MCWord;

        var Buffer: MCWordForm;
            ByteIndex: MCByteIndex;

        begin
          for ByteIndex := 0 to MCMaxByteNum do
            Buffer.WChars[ByteIndex] := chr(NextByte);

          { recast(buffer,asvalue) }
          NextWord := Buffer.WValue
        end { nextword };

      function WordBoundary: WordRange;

        var Address: ByteRange;

        begin
          Address := CodeCounter;
          while Address mod MCBytesPerWord <> 0 do
            Address := Address + 1;
          WordBoundary := Address div MCBytesPerWord
        end { wordboundary };

      procedure PrintDecimal(Byte: PcodeByte);

        var q, r, t: integer;
            i: 1..3;

        begin
          r := Byte;
          t := 100;
          for i := 1 to 3 do
            begin
              q := r div t;
              write(chr(q + ord('0')));
              r := r mod t;
              t := t div 10
            end
        end { printdecimal };

      procedure PrintHex(Word: MCWord);

        type HexIndex = 0..7;
             HexDigit = 0..15;
             HexWord = packed array [HexIndex] of HexDigit;

        var i: HexIndex;
            Next: MCWord;
            HexMap:
              record
                case Boolean of
                  false: (TheWord: MCWord);
                  true: (HexValue: HexWord)
              end;

        procedure Phex(Digit: HexDigit);

          begin
            if Digit > 9
            then write(chr(Digit - 10 + ord('A')))
            else write(chr(Digit + ord('0')))
          end;

        begin
          with HexMap do
            begin
{if compiled with bit packing then begin
              TheWord := Word;
              if HostByteOrder = LeftToRight
              then
                for i := 0 to 7 do Phex(HexValue[i])
              else
                for i := 7 downto 0 do Phex(HexValue[i])
 end else begin }
              for i := 7 downto 0 do begin
                 next := Word div 16;
                 HexValue[i] := word - next*16;
                 word := next;
              end;
              for i := 0 to 7 do Phex(HexValue[i]);
{end}
            end
        end { printhex };

      procedure PrintChars(Word: MCWord);

        var ByteIndex: MCByteIndex;
            ChByte: MCByte;
            Buffer: MCWordForm;

        begin
          Buffer.WValue := Word;
          for ByteIndex := 0 to MCMaxByteNum do
            begin
              MCGetByte(Buffer, ByteIndex, ChByte);
              write(chr(ChByte))
            end
        end { printchars };

      procedure StartCodeLine;

        var CodeByte: ByteRange;
            ByteNum: MCByteIndex;

        begin
          CodeByte := FirstByte + CodeCounter - 1;
          ByteNum := CodeByte mod MCBytesPerWord;
          write(Margin);
          if ByteNum = 0
          then write(CodeByte div MCBytesPerWord: 5)
          else write(' ': 5);
          write(Margin, CodeByte: 6);
          write(' ': MarginWidth + 3 * ByteNum);
          PrintDecimal(OpCode);
          write(' ': MarginWidth + OpFieldWidth - 3 * (ByteNum + 1));
          write(' :')
        end { startcodeline };

      procedure TabToOperands;

        begin
          writeln;
          write(Blanks, ':', Margin, ' ': 6, Margin: 9)
        end { tabtooperands };

      procedure PrintString(Base, Size: CodeRange);

        var ThisWord: MCWord;
            Index: CodeRange;

        begin
          for Index := 1 to Size do
            begin
              if Index > 1 then TabToOperands;
              ThisWord := Code[Base];
              PrintHex(ThisWord);
              write(Margin);
              PrintChars(ThisWord);
              Base := Base + 1
            end
        end { printstring };

      procedure PrintSet(Base, Size: WordRange);

        var ThisWord: MCWord;
            Index: WordRange;

        begin
          for Index := 1 to Size do
            begin
              if Index > 1 then TabToOperands;
              ThisWord := Code[Base];
              PrintHex(ThisWord);
              Base := Base + 1
            end
        end { printset };

      procedure LogOpCode(var Table: Frequencies);

        begin
          Table[OpCode] := Table[OpCode] + 1;
          Logged := Logged + 1
        end { logopcode };

      begin
        writeln(Blanks, ':');
        writeln(Blanks, ':', Margin, 'Code Table');
        writeln(Blanks, ':');
        writeln(Blanks, ':', Margin, 'Pcode ', Margin, 'Argument(s)');
        writeln(Blanks, ':');
        CodeCounter := 0;
        FirstByte := CodeWord * MCBytesPerWord;
        LastByte := CodeSize * MCBytesPerWord;
        repeat
          OpCode := NextByte;
          LogOpCode(Pcounts[Class1]);
          StartCodeLine;
          write(Margin);
          if OpCode in [consb..csetw]
          then
            begin
              write(ModelPcode[Class1, OpCode].Mnemonic);
              case OpCode of

                { in-line single constants }

                consb :
                  begin
                    Datum := NextByte;
                    write(Datum: 10);
                    if (Datum >= 0) and (Datum <= MaxHostChar)
                    then write('  ''', chr(Datum), '''')
                  end;

                { in-line multiple constants }

                consw :
                  begin
                    Datum := NextWord;
                    write(' ': 9);
                    PrintHex(Datum);
                    writeln
                  end;
                conmb, conmw, crefb, crefw :
                  begin
                    case OpCode of
                      conmb : Size := NextByte;
                      conmw : Size := NextWord;
                      crefb : Size := NextByte;
                      crefw : Size := NextWord
                    end;
                    write(' ': 9);
                    CodeBase := WordBoundary;
                    PrintString(CodeBase, Size);
                    writeln;
                    CodeCounter := (CodeBase + Size) * MCBytesPerWord
                  end;
                csetb, csetw :
                  begin
                    case OpCode of
                      csetb : Size := NextByte;
                      csetw : Size := NextWord
                    end;
                    write(Margin);
                    CodeBase := WordBoundary;
                    PrintSet(CodeBase, Size);
                    writeln;
                    CodeCounter := (CodeBase + Size) * MCBytesPerWord
                  end
              end
            end
          else
            begin
              if OpCode = escape
              then
                begin
                  OpCode := NextByte;
                  LogOpCode(Pcounts[Class2]);
                  writeln;
                  StartCodeLine;
                  write(Margin);
                  Instruction := ModelPcode[Class2, OpCode]
                end
              else Instruction := ModelPcode[Class1, OpCode];
              with Instruction do
                begin
                  write(Mnemonic);
                  case Operands of
                    Implicit : ;
                    Byte : write(NextByte: 10);
                    DoubleByte :
                      begin
                        write(NextByte: 10);
                        write(NextByte: 10)
                      end;
                    ByteString :
                      begin
                        Size := NextByte;
                        write(Size: 5, NextByte: 5, Margin);
                        Size := Size - 1;
                        while Size > 0 do
                          begin
                            write(chr(NextByte): 1);
                            Size := Size - 1
                          end
                      end;
                    Word : write(NextWord: 20);
                    WordByte :
                      begin
                        write(NextWord: 20);
                        write(NextByte: 10)
                      end;
                    Table :
                      begin
                        CodeCounter := WordBoundary * MCBytesPerWord;
                        Min := NextWord;
                        Max := NextWord;
                        write(' ': 9);
                        PrintHex(Min);
                        write(Margin, Min);
                        TabToOperands;
                        PrintHex(Max);
                        write(Margin, Max);
                        for i := 1 to Max - Min + 1 do
                          begin
                            Datum := NextWord;
                            TabToOperands;
                            PrintHex(Datum);
                            write(Margin, Datum);
                            write
                              (' -> ',
                                 CodeCounter - MCBytesPerWord + Datum)
                          end
                      end;
                    None :
                  end
                end
            end;
          writeln
        until CodeCounter = LastByte;
        CodeWord := CodeWord + CodeSize
      end { codetable };

    begin
      if DataSize > 0 then JumpTable;
      if CodeSize > 0 then CodeTable
    end { displaytables };

  begin
    CodeWord := 0;
    while not eof(CodeMap) do
      begin
        ReadSizes;
        ReadTables;
        DisplayTables
      end;
    writeln;
    writeln;
    writeln(' External Data = ', CodeFile^: 10)
  end { disassemble };

procedure InitPcodes;

  var Class: PcodeClasses;
      NextCode, Index: 0..256;

  procedure Pcode(OpName: SixChars; OpForm: OpForms);

    begin
      with ModelPcode[Class, NextCode] do
        begin
          Mnemonic := OpName;
          Operands := OpForm
        end;
      NextCode := NextCode + 1
    end { pcode };

  begin { class 1 p-codes }
    Class := Class1;
    NextCode := 0;
    Pcode('cons0 ', Implicit);
    Pcode('cons1 ', Implicit);
    Pcode('cons2 ', Implicit);
    Pcode('cons3 ', Implicit);
    Pcode('cons4 ', Implicit);
    Pcode('cons5 ', Implicit);
    Pcode('cons6 ', Implicit);
    Pcode('cons7 ', Implicit);
    Pcode('cons8 ', Implicit);
    Pcode('cons9 ', Implicit);
    Pcode('cons10', Implicit);
    Pcode('cons11', Implicit);
    Pcode('cons12', Implicit);
    Pcode('cons13', Implicit);
    Pcode('cons14', Implicit);
    Pcode('cons15', Implicit);
    Pcode('cons16', Implicit);
    Pcode('cons17', Implicit);
    Pcode('cons18', Implicit);
    Pcode('cons19', Implicit);
    Pcode('cons20', Implicit);
    Pcode('cons21', Implicit);
    Pcode('cons22', Implicit);
    Pcode('cons23', Implicit);
    Pcode('cons24', Implicit);
    Pcode('cons25', Implicit);
    Pcode('cons26', Implicit);
    Pcode('cons27', Implicit);
    Pcode('cons28', Implicit);
    Pcode('cons29', Implicit);
    Pcode('cons30', Implicit);
    Pcode('cons31', Implicit);
    Pcode('consb ', Byte);
    Pcode('consw ', Word);
    Pcode('conmb ', Byte);
    Pcode('conmw ', Word);
    Pcode('crefb ', Byte);
    Pcode('crefw ', Word);
    Pcode('csetb ', Byte);
    Pcode('csetw ', Word);
    Pcode('lodl0 ', Implicit);
    Pcode('lodl1 ', Implicit);
    Pcode('lodl2 ', Implicit);
    Pcode('lodl3 ', Implicit);
    Pcode('lodl4 ', Implicit);
    Pcode('lodl5 ', Implicit);
    Pcode('lodl6 ', Implicit);
    Pcode('lodl7 ', Implicit);
    Pcode('lodlb ', Byte);
    Pcode('lodlw ', Word);
    Pcode('lrf0  ', Implicit);
    Pcode('lrf1  ', Implicit);
    Pcode('lrf2  ', Implicit);
    Pcode('lrf3  ', Implicit);
    Pcode('lrf4  ', Implicit);
    Pcode('lrf5  ', Implicit);
    Pcode('lrf6  ', Implicit);
    Pcode('lrf7  ', Implicit);
    Pcode('lrflb ', Byte);
    Pcode('lrflw ', Word);
    Pcode('stol0 ', Implicit);
    Pcode('stol1 ', Implicit);
    Pcode('stol2 ', Implicit);
    Pcode('stol3 ', Implicit);
    Pcode('stol4 ', Implicit);
    Pcode('stol5 ', Implicit);
    Pcode('stol6 ', Implicit);
    Pcode('stol7 ', Implicit);
    Pcode('stolb ', Byte);
    Pcode('stolw ', Word);
    Pcode('lodgb ', Byte);
    Pcode('lodgw ', Word);
    Pcode('lrfgb ', Byte);
    Pcode('lrfgw ', Word);
    Pcode('stogb ', Byte);
    Pcode('stogw ', Word);
    Pcode('lodeb ', Byte);
    Pcode('lodew ', Word);
    Pcode('lrfeb ', Byte);
    Pcode('lrfew ', Word);
    Pcode('stoeb ', Byte);
    Pcode('stoew ', Word);
    Pcode('lodib ', DoubleByte);
    Pcode('lodiw ', WordByte);
    Pcode('lrfib ', DoubleByte);
    Pcode('lrfiw ', WordByte);
    Pcode('stoib ', DoubleByte);
    Pcode('stoiw ', WordByte);
    Pcode('lodin ', None);
    Pcode('indx1 ', Implicit);
    Pcode('indx2 ', Implicit);
    Pcode('indx3 ', Implicit);
    Pcode('indx4 ', Implicit);
    Pcode('indx5 ', Implicit);
    Pcode('indx6 ', Implicit);
    Pcode('indx7 ', Implicit);
    Pcode('indxb ', Byte);
    Pcode('indxw ', Word);
    Pcode('ixrfb ', Byte);
    Pcode('ixrfw ', Word);
    Pcode('ixcap ', None);
    Pcode('stoin ', None);
    Pcode('adjpb ', Byte);
    Pcode('adjpw ', Word);
    Pcode('adjp1 ', None);
    Pcode('adjmb ', Byte);
    Pcode('adjmw ', Word);
    Pcode('adjm1 ', None);
    Pcode('adadr ', None);
    Pcode('lodbt ', Byte);
    Pcode('lodpk ', None);
    Pcode('stobt ', Byte);
    Pcode('stopk ', None);
    Pcode('ixpkb ', Byte);
    Pcode('ixpcap', None);
    Pcode('ixswb ', Byte);
    Pcode('adjpk ', None);
    Pcode('lodby ', None);
    Pcode('stoby ', None);
    Pcode('lbyrf ', None);
    Pcode('ibyrf ', None);
    Pcode('lodmb ', Byte);
    Pcode('lodmw ', Word);
    Pcode('stomb ', Byte);
    Pcode('stomw ', Word);
    Pcode('storb ', Byte);
    Pcode('storw ', Word);
    Pcode('moveb ', Byte);
    Pcode('movew ', Word);
    Pcode('szcap ', None);
    Pcode('mvcap ', None);
    Pcode('dpcap ', None);
    Pcode('rlcap ', None);
    Pcode('andop ', None);
    Pcode('notop ', None);
    Pcode('incrb ', Byte);
    Pcode('incrw ', Word);
    Pcode('incr1 ', None);
    Pcode('decrb ', Byte);
    Pcode('decrw ', Word);
    Pcode('decr1 ', None);
    Pcode('absint', None);
    Pcode('negint', None);
    Pcode('sqrint', None);
    Pcode('addint', None);
    Pcode('subint', None);
    Pcode('mulint', None);
    Pcode('divint', None);
    Pcode('modint', None);
    Pcode('oddint', None);
    Pcode('eqint ', None);
    Pcode('neint ', None);
    Pcode('ltint ', None);
    Pcode('leint ', None);
    Pcode('chktv ', Byte);
    Pcode('chktd ', Byte);
    Pcode('chklm ', Byte);
    Pcode('chklw ', Byte);
    Pcode('chkup ', Byte);
    Pcode('chkcap', Byte);
    Pcode('float ', None);
    Pcode('absrl ', None);
    Pcode('negrl ', None);
    Pcode('sqrl  ', None);
    Pcode('addrl ', None);
    Pcode('subrl ', None);
    Pcode('mulrl ', None);
    Pcode('divrl ', None);
    Pcode('trurl ', None);
    Pcode('rndrl ', None);
    Pcode('eqrl  ', None);
    Pcode('nerl  ', None);
    Pcode('ltrl  ', None);
    Pcode('lerl  ', None);
    Pcode('lodptr', None);
    Pcode('eqptr ', None);
    Pcode('neptr ', None);
    Pcode('eqstr ', Word);
    Pcode('nestr ', Word);
    Pcode('ltstr ', Word);
    Pcode('lestr ', Word);
    Pcode('lodset', Byte);
    Pcode('stoset', Byte);
    Pcode('sglset', None);
    Pcode('rngset', None);
    Pcode('setuni', None);
    Pcode('setint', None);
    Pcode('setdif', None);
    Pcode('setexp', Byte);
    Pcode('eqset ', None);
    Pcode('neset ', None);
    Pcode('leset ', None);
    Pcode('inset ', None);
    Pcode('chksl ', Byte);
    Pcode('chksu ', Byte);
    Pcode('jmpfw ', Byte);
    Pcode('jmpbk ', Byte);
    Pcode('jmpvia', Byte);
    Pcode('jmpout', DoubleByte);
    Pcode('fjpfw ', Byte);
    Pcode('fjpbk ', Byte);
    Pcode('fjpvia', Byte);
    Pcode('fjpcnd', Byte);
    Pcode('tjpcnd', Byte);
    Pcode('casejp', Table);
    Pcode('mark  ', None);
    Pcode('calglo', Byte);
    Pcode('calloc', Byte);
    Pcode('callev', Byte);
    Pcode('calotr', DoubleByte);
    Pcode('calfml', None);
    Pcode('endp  ', None);
    Pcode('endf  ', None);
    Pcode('endmf ', Byte);
    Pcode('newp1b', Byte);
    Pcode('newp1w', Word);
    Pcode('dspp1b', Byte);
    Pcode('dspp1w', Word);
    Pcode('chkn1 ', None);
    Pcode('chkd1 ', None);
    Pcode('chkd2 ', Byte);
    Pcode('noop  ', None);
    Pcode('preset', None);
    Pcode('presrb', Byte);
    Pcode('presrw', Word);
    Pcode('ldstk ', Byte);
    Pcode('dpstk ', None);
    Pcode('popstk', None);
    Pcode('chkwd ', Byte);
    Pcode('chkrp ', Byte);
    Pcode('chkvf ', Byte);
    Pcode('trapp ', Byte);
    Pcode('trapt ', Byte);
    Pcode('trapf ', Byte);
    Pcode('setlk ', Byte);
    Pcode('dislk ', Byte);
    Pcode('pglk  ', None);
    Pcode('smpglk', None);
    Pcode('haltp ', None);
    Pcode('      ', None);
    Pcode('      ', None);
    Pcode('chkptr', None);
    Pcode('chkflw', Byte);
    Pcode('chkfup', Byte);
    for Index := NextCode to 254 do Pcode('      ', None);
    NextCode := 255;
    Pcode('escape', None);

    { class 2 p-codes }
    Class := Class2;
    NextCode := 0;
    Pcode('chkrd ', None);
    Pcode('chkwr ', None);
    Pcode('rewrtf', None);
    Pcode('resetf', None);
    Pcode('eolnf ', None);
    Pcode('eoff  ', None);
    Pcode('getf  ', None);
    Pcode('rdint ', None);
    Pcode('rdrl  ', None);
    Pcode('rdln  ', None);
    Pcode('putf  ', None);
    Pcode('wrchar', None);
    Pcode('wrbool', None);
    Pcode('wrstr ', None);
    Pcode('wrint ', None);
    Pcode('wrflt ', None);
    Pcode('wrfix ', None);
    Pcode('wrln  ', None);
    Pcode('pagef ', None);
    Pcode('closef', None);
    Pcode('pckpr ', Byte);
    Pcode('pckprc', Byte);
    Pcode('upkpr ', Byte);
    Pcode('upkprc', Byte);
    Pcode('sinf  ', None);
    Pcode('cosf  ', None);
    Pcode('expf  ', None);
    Pcode('logf  ', None);
    Pcode('sqrtf ', None);
    Pcode('arctnf', None);
    Pcode('mapp  ', ByteString);
    Pcode('chkbuf', None);
    for Index := NextCode to 255 do Pcode('      ', None)
  end { initpcodes };

procedure InitListing;

  var Option: OptionType;
      FirstOne: Boolean;

  begin
    page(Output);
    writeln;
    writeln
      (' Model P-code Disassembler Version ', VerNum: 1, '.',
         RelNum: 1, '.');
    write(' Boolean Options = [');
    FirstOne := true;
    for Option := CodeDump to PMDump do
      if Control[Option] <> 0
      then
        begin
          if not FirstOne then write(',');
          case Option of
            CodeDump : write('CODE');
            Checks : write('CHECKS');
            PMDump : write('PMDUMP')
          end;
          FirstOne := false
        end;
    writeln(']');
    writeln;
    writeln;
    writeln;
    writeln
      (' ': 14, 'P-machine Memory', ' ': 14, ':', ' ': 14,
         'CodeFile Segments')
  end { initlisting };

procedure InitFiles;

  begin
    reset(CodeFile);
    reset(CodeMap)
  end { initfiles };

procedure InitControl;

  var Option: OptionType;

  begin
    for Option := Listing to Other do
      if eof(CodeFile)
      then Error(1)
      else
        begin
          Control[Option] := CodeFile^;
          get(CodeFile)
        end
  end { initcontrol };

procedure InitStats;

  var Class: PcodeClasses;
      Pcode: PcodeByte;

  begin
    Logged := 0;
    for Class := Class1 to Class2 do
      for Pcode := 0 to 255 do Pcounts[Class, Pcode] := 0
  end { initstats };

procedure PrintStats;

  var Class: PcodeClasses;
      i: Scalar;

  procedure NewPage;

    begin
      page(Output);
      writeln
    end { newpage };

  procedure PrintTable(var Table: Frequencies);

    var Count: Scalar;
        Pcode: PcodeByte;

    begin
      for Pcode := 0 to 255 do
        begin
          Count := Pcounts[Class, Pcode];
          if Count > 0
          then
            begin
              write
                (' ', Pcode: 11, ' ',
                   ModelPcode[Class, Pcode].Mnemonic: 12);
              writeln(Count: 11, ' ', Count * 100.0 / Logged: 12: 1)
            end
        end
    end { printtable };

  begin
    for Class := Class1 to Class2 do
      begin
        NewPage;
        write
          ('Opcode': 14, 'Pcode': 12, 'Count': 12, '%-age': 12,
             '(Class': 12);
        if Class = Class1 then write('1)') else write('2)');
        writeln;
        writeln;
        write(' ');
        for i := 1 to 48 do write('-');
        writeln;
        writeln;
        PrintTable(Pcounts[Class])
      end
  end { printstats };

begin
  InitPcodes;
  InitFiles;
  InitControl;
  InitListing;
  InitStats;
  Disassemble;
  PrintStats;
13:
end.
